
-- hud stuff
-- yay :D

local function draw5BString(v, x, y, scale, string, flags, alignment)
	if v == nil
	or x == nil
	or y == nil
	or string == nil return end
	
	scale = $ or FU
	flags = $ or 0
	alignment = $ or "left"
	string = tostring($)
	
	local len = string.len(string)
	local prevX = x
	for i = 1, len do
		local curLet = string.sub(string, i, i)
		local size = ((string.upper(curLet) == curLet) and "U") or "L"
		
		local symbt = {}
		symbt["."] = "DOT"
		if symbt[curLet]
			curLet = symbt[$]
			size = ""
		end
		
		if tonumber(curLet) ~= nil size = "" end
		
		local ltr = v.cachePatch("5BFNT"+curLet+size)
		local sdraw = true
		
		if curLet == " "
		or curLet == ""
			sdraw = false
		end
		
		if sdraw
			v.drawScaled(prevX, y, scale, ltr, flags)
			prevX = $+(ltr.width*scale)
		else
			prevX = $+(8*scale)
		end
	end
end

addHook("ThinkFrame", function()
	if not displayplayer return end
	
	local p = displayplayer
	
	if (p.mo.skin ~= "book" and p.mo.skin ~= "icecube" and p.mo.skin ~= "match")
		if not hud.enabled("lives")
		and p.fbhudactive -- f stands for five since uhhh i cant do 5b
			hud.enable("lives")
			p.fbhudactive = false
			--print(p.mo.skin)
		end
	elseif hud.enabled("lives")
	and not p.fbhudactive
		hud.disable("lives")
		p.fbhudactive = true
	end
end)

addHook("HUD", function(v, p)
	if not (p.mo and p.mo.valid)
	or (p.mo.skin ~= "book" and p.mo.skin ~= "icecube" and p.mo.skin ~= "match") return end -- gotta make this a function soon
	
	local name = mapheaderinfo[gamemap].lvlttl
	local mnum = ((gamemap ~= tutorialmap) and gamemap) or 0
	local mstr = (G_CoopGametype() and mnum+". ") or ""
	local actnum = mapheaderinfo[gamemap].actnum
	local actstr = ((actnum ~= 0) and (" act "+actnum)) or ""
	
	draw5BString(v, 4*FU, 184*FU, FU/2, mstr+name+actstr, V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS)
end, "game")